use crate::Code;

const fn code(op: u8, bits: u8, val: u16) -> Code {
    Code { op, bits, val }
}

pub(crate) const LENFIX: [Code; 512] = [
    code(96, 7, 0),
    code(0, 8, 80),
    code(0, 8, 16),
    code(20, 8, 115),
    code(18, 7, 31),
    code(0, 8, 112),
    code(0, 8, 48),
    code(0, 9, 192),
    code(16, 7, 10),
    code(0, 8, 96),
    code(0, 8, 32),
    code(0, 9, 160),
    code(0, 8, 0),
    code(0, 8, 128),
    code(0, 8, 64),
    code(0, 9, 224),
    code(16, 7, 6),
    code(0, 8, 88),
    code(0, 8, 24),
    code(0, 9, 144),
    code(19, 7, 59),
    code(0, 8, 120),
    code(0, 8, 56),
    code(0, 9, 208),
    code(17, 7, 17),
    code(0, 8, 104),
    code(0, 8, 40),
    code(0, 9, 176),
    code(0, 8, 8),
    code(0, 8, 136),
    code(0, 8, 72),
    code(0, 9, 240),
    code(16, 7, 4),
    code(0, 8, 84),
    code(0, 8, 20),
    code(21, 8, 227),
    code(19, 7, 43),
    code(0, 8, 116),
    code(0, 8, 52),
    code(0, 9, 200),
    code(17, 7, 13),
    code(0, 8, 100),
    code(0, 8, 36),
    code(0, 9, 168),
    code(0, 8, 4),
    code(0, 8, 132),
    code(0, 8, 68),
    code(0, 9, 232),
    code(16, 7, 8),
    code(0, 8, 92),
    code(0, 8, 28),
    code(0, 9, 152),
    code(20, 7, 83),
    code(0, 8, 124),
    code(0, 8, 60),
    code(0, 9, 216),
    code(18, 7, 23),
    code(0, 8, 108),
    code(0, 8, 44),
    code(0, 9, 184),
    code(0, 8, 12),
    code(0, 8, 140),
    code(0, 8, 76),
    code(0, 9, 248),
    code(16, 7, 3),
    code(0, 8, 82),
    code(0, 8, 18),
    code(21, 8, 163),
    code(19, 7, 35),
    code(0, 8, 114),
    code(0, 8, 50),
    code(0, 9, 196),
    code(17, 7, 11),
    code(0, 8, 98),
    code(0, 8, 34),
    code(0, 9, 164),
    code(0, 8, 2),
    code(0, 8, 130),
    code(0, 8, 66),
    code(0, 9, 228),
    code(16, 7, 7),
    code(0, 8, 90),
    code(0, 8, 26),
    code(0, 9, 148),
    code(20, 7, 67),
    code(0, 8, 122),
    code(0, 8, 58),
    code(0, 9, 212),
    code(18, 7, 19),
    code(0, 8, 106),
    code(0, 8, 42),
    code(0, 9, 180),
    code(0, 8, 10),
    code(0, 8, 138),
    code(0, 8, 74),
    code(0, 9, 244),
    code(16, 7, 5),
    code(0, 8, 86),
    code(0, 8, 22),
    code(64, 8, 0),
    code(19, 7, 51),
    code(0, 8, 118),
    code(0, 8, 54),
    code(0, 9, 204),
    code(17, 7, 15),
    code(0, 8, 102),
    code(0, 8, 38),
    code(0, 9, 172),
    code(0, 8, 6),
    code(0, 8, 134),
    code(0, 8, 70),
    code(0, 9, 236),
    code(16, 7, 9),
    code(0, 8, 94),
    code(0, 8, 30),
    code(0, 9, 156),
    code(20, 7, 99),
    code(0, 8, 126),
    code(0, 8, 62),
    code(0, 9, 220),
    code(18, 7, 27),
    code(0, 8, 110),
    code(0, 8, 46),
    code(0, 9, 188),
    code(0, 8, 14),
    code(0, 8, 142),
    code(0, 8, 78),
    code(0, 9, 252),
    code(96, 7, 0),
    code(0, 8, 81),
    code(0, 8, 17),
    code(21, 8, 131),
    code(18, 7, 31),
    code(0, 8, 113),
    code(0, 8, 49),
    code(0, 9, 194),
    code(16, 7, 10),
    code(0, 8, 97),
    code(0, 8, 33),
    code(0, 9, 162),
    code(0, 8, 1),
    code(0, 8, 129),
    code(0, 8, 65),
    code(0, 9, 226),
    code(16, 7, 6),
    code(0, 8, 89),
    code(0, 8, 25),
    code(0, 9, 146),
    code(19, 7, 59),
    code(0, 8, 121),
    code(0, 8, 57),
    code(0, 9, 210),
    code(17, 7, 17),
    code(0, 8, 105),
    code(0, 8, 41),
    code(0, 9, 178),
    code(0, 8, 9),
    code(0, 8, 137),
    code(0, 8, 73),
    code(0, 9, 242),
    code(16, 7, 4),
    code(0, 8, 85),
    code(0, 8, 21),
    code(16, 8, 258),
    code(19, 7, 43),
    code(0, 8, 117),
    code(0, 8, 53),
    code(0, 9, 202),
    code(17, 7, 13),
    code(0, 8, 101),
    code(0, 8, 37),
    code(0, 9, 170),
    code(0, 8, 5),
    code(0, 8, 133),
    code(0, 8, 69),
    code(0, 9, 234),
    code(16, 7, 8),
    code(0, 8, 93),
    code(0, 8, 29),
    code(0, 9, 154),
    code(20, 7, 83),
    code(0, 8, 125),
    code(0, 8, 61),
    code(0, 9, 218),
    code(18, 7, 23),
    code(0, 8, 109),
    code(0, 8, 45),
    code(0, 9, 186),
    code(0, 8, 13),
    code(0, 8, 141),
    code(0, 8, 77),
    code(0, 9, 250),
    code(16, 7, 3),
    code(0, 8, 83),
    code(0, 8, 19),
    code(21, 8, 195),
    code(19, 7, 35),
    code(0, 8, 115),
    code(0, 8, 51),
    code(0, 9, 198),
    code(17, 7, 11),
    code(0, 8, 99),
    code(0, 8, 35),
    code(0, 9, 166),
    code(0, 8, 3),
    code(0, 8, 131),
    code(0, 8, 67),
    code(0, 9, 230),
    code(16, 7, 7),
    code(0, 8, 91),
    code(0, 8, 27),
    code(0, 9, 150),
    code(20, 7, 67),
    code(0, 8, 123),
    code(0, 8, 59),
    code(0, 9, 214),
    code(18, 7, 19),
    code(0, 8, 107),
    code(0, 8, 43),
    code(0, 9, 182),
    code(0, 8, 11),
    code(0, 8, 139),
    code(0, 8, 75),
    code(0, 9, 246),
    code(16, 7, 5),
    code(0, 8, 87),
    code(0, 8, 23),
    code(64, 8, 0),
    code(19, 7, 51),
    code(0, 8, 119),
    code(0, 8, 55),
    code(0, 9, 206),
    code(17, 7, 15),
    code(0, 8, 103),
    code(0, 8, 39),
    code(0, 9, 174),
    code(0, 8, 7),
    code(0, 8, 135),
    code(0, 8, 71),
    code(0, 9, 238),
    code(16, 7, 9),
    code(0, 8, 95),
    code(0, 8, 31),
    code(0, 9, 158),
    code(20, 7, 99),
    code(0, 8, 127),
    code(0, 8, 63),
    code(0, 9, 222),
    code(18, 7, 27),
    code(0, 8, 111),
    code(0, 8, 47),
    code(0, 9, 190),
    code(0, 8, 15),
    code(0, 8, 143),
    code(0, 8, 79),
    code(0, 9, 254),
    code(96, 7, 0),
    code(0, 8, 80),
    code(0, 8, 16),
    code(20, 8, 115),
    code(18, 7, 31),
    code(0, 8, 112),
    code(0, 8, 48),
    code(0, 9, 193),
    code(16, 7, 10),
    code(0, 8, 96),
    code(0, 8, 32),
    code(0, 9, 161),
    code(0, 8, 0),
    code(0, 8, 128),
    code(0, 8, 64),
    code(0, 9, 225),
    code(16, 7, 6),
    code(0, 8, 88),
    code(0, 8, 24),
    code(0, 9, 145),
    code(19, 7, 59),
    code(0, 8, 120),
    code(0, 8, 56),
    code(0, 9, 209),
    code(17, 7, 17),
    code(0, 8, 104),
    code(0, 8, 40),
    code(0, 9, 177),
    code(0, 8, 8),
    code(0, 8, 136),
    code(0, 8, 72),
    code(0, 9, 241),
    code(16, 7, 4),
    code(0, 8, 84),
    code(0, 8, 20),
    code(21, 8, 227),
    code(19, 7, 43),
    code(0, 8, 116),
    code(0, 8, 52),
    code(0, 9, 201),
    code(17, 7, 13),
    code(0, 8, 100),
    code(0, 8, 36),
    code(0, 9, 169),
    code(0, 8, 4),
    code(0, 8, 132),
    code(0, 8, 68),
    code(0, 9, 233),
    code(16, 7, 8),
    code(0, 8, 92),
    code(0, 8, 28),
    code(0, 9, 153),
    code(20, 7, 83),
    code(0, 8, 124),
    code(0, 8, 60),
    code(0, 9, 217),
    code(18, 7, 23),
    code(0, 8, 108),
    code(0, 8, 44),
    code(0, 9, 185),
    code(0, 8, 12),
    code(0, 8, 140),
    code(0, 8, 76),
    code(0, 9, 249),
    code(16, 7, 3),
    code(0, 8, 82),
    code(0, 8, 18),
    code(21, 8, 163),
    code(19, 7, 35),
    code(0, 8, 114),
    code(0, 8, 50),
    code(0, 9, 197),
    code(17, 7, 11),
    code(0, 8, 98),
    code(0, 8, 34),
    code(0, 9, 165),
    code(0, 8, 2),
    code(0, 8, 130),
    code(0, 8, 66),
    code(0, 9, 229),
    code(16, 7, 7),
    code(0, 8, 90),
    code(0, 8, 26),
    code(0, 9, 149),
    code(20, 7, 67),
    code(0, 8, 122),
    code(0, 8, 58),
    code(0, 9, 213),
    code(18, 7, 19),
    code(0, 8, 106),
    code(0, 8, 42),
    code(0, 9, 181),
    code(0, 8, 10),
    code(0, 8, 138),
    code(0, 8, 74),
    code(0, 9, 245),
    code(16, 7, 5),
    code(0, 8, 86),
    code(0, 8, 22),
    code(64, 8, 0),
    code(19, 7, 51),
    code(0, 8, 118),
    code(0, 8, 54),
    code(0, 9, 205),
    code(17, 7, 15),
    code(0, 8, 102),
    code(0, 8, 38),
    code(0, 9, 173),
    code(0, 8, 6),
    code(0, 8, 134),
    code(0, 8, 70),
    code(0, 9, 237),
    code(16, 7, 9),
    code(0, 8, 94),
    code(0, 8, 30),
    code(0, 9, 157),
    code(20, 7, 99),
    code(0, 8, 126),
    code(0, 8, 62),
    code(0, 9, 221),
    code(18, 7, 27),
    code(0, 8, 110),
    code(0, 8, 46),
    code(0, 9, 189),
    code(0, 8, 14),
    code(0, 8, 142),
    code(0, 8, 78),
    code(0, 9, 253),
    code(96, 7, 0),
    code(0, 8, 81),
    code(0, 8, 17),
    code(21, 8, 131),
    code(18, 7, 31),
    code(0, 8, 113),
    code(0, 8, 49),
    code(0, 9, 195),
    code(16, 7, 10),
    code(0, 8, 97),
    code(0, 8, 33),
    code(0, 9, 163),
    code(0, 8, 1),
    code(0, 8, 129),
    code(0, 8, 65),
    code(0, 9, 227),
    code(16, 7, 6),
    code(0, 8, 89),
    code(0, 8, 25),
    code(0, 9, 147),
    code(19, 7, 59),
    code(0, 8, 121),
    code(0, 8, 57),
    code(0, 9, 211),
    code(17, 7, 17),
    code(0, 8, 105),
    code(0, 8, 41),
    code(0, 9, 179),
    code(0, 8, 9),
    code(0, 8, 137),
    code(0, 8, 73),
    code(0, 9, 243),
    code(16, 7, 4),
    code(0, 8, 85),
    code(0, 8, 21),
    code(16, 8, 258),
    code(19, 7, 43),
    code(0, 8, 117),
    code(0, 8, 53),
    code(0, 9, 203),
    code(17, 7, 13),
    code(0, 8, 101),
    code(0, 8, 37),
    code(0, 9, 171),
    code(0, 8, 5),
    code(0, 8, 133),
    code(0, 8, 69),
    code(0, 9, 235),
    code(16, 7, 8),
    code(0, 8, 93),
    code(0, 8, 29),
    code(0, 9, 155),
    code(20, 7, 83),
    code(0, 8, 125),
    code(0, 8, 61),
    code(0, 9, 219),
    code(18, 7, 23),
    code(0, 8, 109),
    code(0, 8, 45),
    code(0, 9, 187),
    code(0, 8, 13),
    code(0, 8, 141),
    code(0, 8, 77),
    code(0, 9, 251),
    code(16, 7, 3),
    code(0, 8, 83),
    code(0, 8, 19),
    code(21, 8, 195),
    code(19, 7, 35),
    code(0, 8, 115),
    code(0, 8, 51),
    code(0, 9, 199),
    code(17, 7, 11),
    code(0, 8, 99),
    code(0, 8, 35),
    code(0, 9, 167),
    code(0, 8, 3),
    code(0, 8, 131),
    code(0, 8, 67),
    code(0, 9, 231),
    code(16, 7, 7),
    code(0, 8, 91),
    code(0, 8, 27),
    code(0, 9, 151),
    code(20, 7, 67),
    code(0, 8, 123),
    code(0, 8, 59),
    code(0, 9, 215),
    code(18, 7, 19),
    code(0, 8, 107),
    code(0, 8, 43),
    code(0, 9, 183),
    code(0, 8, 11),
    code(0, 8, 139),
    code(0, 8, 75),
    code(0, 9, 247),
    code(16, 7, 5),
    code(0, 8, 87),
    code(0, 8, 23),
    code(64, 8, 0),
    code(19, 7, 51),
    code(0, 8, 119),
    code(0, 8, 55),
    code(0, 9, 207),
    code(17, 7, 15),
    code(0, 8, 103),
    code(0, 8, 39),
    code(0, 9, 175),
    code(0, 8, 7),
    code(0, 8, 135),
    code(0, 8, 71),
    code(0, 9, 239),
    code(16, 7, 9),
    code(0, 8, 95),
    code(0, 8, 31),
    code(0, 9, 159),
    code(20, 7, 99),
    code(0, 8, 127),
    code(0, 8, 63),
    code(0, 9, 223),
    code(18, 7, 27),
    code(0, 8, 111),
    code(0, 8, 47),
    code(0, 9, 191),
    code(0, 8, 15),
    code(0, 8, 143),
    code(0, 8, 79),
    code(0, 9, 255),
];

pub(crate) const DISTFIX: [Code; 32] = [
    code(16, 5, 1),
    code(23, 5, 257),
    code(19, 5, 17),
    code(27, 5, 4097),
    code(17, 5, 5),
    code(25, 5, 1025),
    code(21, 5, 65),
    code(29, 5, 16385),
    code(16, 5, 3),
    code(24, 5, 513),
    code(20, 5, 33),
    code(28, 5, 8193),
    code(18, 5, 9),
    code(26, 5, 2049),
    code(22, 5, 129),
    code(64, 5, 0),
    code(16, 5, 2),
    code(23, 5, 385),
    code(19, 5, 25),
    code(27, 5, 6145),
    code(17, 5, 7),
    code(25, 5, 1537),
    code(21, 5, 97),
    code(29, 5, 24577),
    code(16, 5, 4),
    code(24, 5, 769),
    code(20, 5, 49),
    code(28, 5, 12289),
    code(18, 5, 13),
    code(26, 5, 3073),
    code(22, 5, 193),
    code(64, 5, 0),
];
